/* =====================================================================
 * NetArduino for showing weather forecast and time from the internet
 * ---------------------------------------------------------------------
 * utilfuncs.cpp
 * 	General purpose functions used across the project
 * =====================================================================
 * By: Zakie Mashiah
 * =====================================================================
 * Copyright
 *  You may use this code with single condition of giving visible
 *  credit to the author.
 * =====================================================================
 * TODO
 *		Extend Serial to have printP functions with for program space strings
 *		
 * =====================================================================
 *  Revision History
 *      31-Oct-2011 v0.9
 * =====================================================================
 */
#include <avr/pgmspace.h>
#include <stdio.h>
#include <WProgram.h>
#include "utilfuncs.h"


static char ipPrintBuff[20];
static int 	ipPrintPos;

static void _print_3_digits(uint8_t c)
{
  int h, d, u, nibble;
  
  nibble = c;
  h = nibble / 100;
  nibble -= h*100;
  d = nibble / 10;
  nibble -= d*10;
  u = nibble;
 ipPrintBuff[ipPrintPos] = '0' + h;
 ipPrintPos++;
 ipPrintBuff[ipPrintPos] = '0' + d;
 ipPrintPos++;
 ipPrintBuff[ipPrintPos] = '0' + u;
}



// Just a utility function to nicely format an IP address.
const char* ip_to_str(const uint8_t* ipAddr)
{
  int i;
  
  ipPrintPos = 0;
  for(i=0; i<4; i++)
  {
    _print_3_digits(ipAddr[i]);
    ipPrintPos++;
    if (i < 3)
    {
      ipPrintBuff[ipPrintPos] = '.';
      ipPrintPos++;
    }
    else
      ipPrintBuff[ipPrintPos] = 0;
  }
  return ipPrintBuff;
}



void Console_printP(const char *s)
{
	while( pgm_read_byte(s) != 0 )
		Console.print( pgm_read_byte(s++) );
}



void Console_printlnP(const char *s)
{
	Console_printP(s);
	Console.println();
}